typedef float RCOEF;
typedef RCOEF * RCOEFBUFFER;
typedef RCOEF RBLOCK[DCTSIZE2];
typedef RBLOCK * RBLOCKROW;
typedef RBLOCKROW * RBLOCKARRAY;

typedef float RSAMP;
typedef RSAMP * RSAMPROW;
typedef RSAMP * RSAMPBUFFER;
typedef RSAMPROW * RSAMPARRAY;

GLOBAL(RBLOCKARRAY)
rest_rbarray_malloc(j_decompress_ptr cinfo, const int width,
    const int height);

GLOBAL(RSAMPARRAY)
rest_rsarray_alloc(j_decompress_ptr cinfo, const int width, const int height);

GLOBAL(RCOEFBUFFER)
rest_rcbuffer_malloc(j_decompress_ptr cinfo, const int elements);

GLOBAL(RSAMPBUFFER)
rest_rsbuffer_malloc(j_decompress_ptr cinfo, const int elements);

GLOBAL(void)
rest_rsbuffer_zero(RSAMPBUFFER buf, const int elements);

GLOBAL(void)
fdct_image (RCOEFBUFFER coefdct, RSAMPBUFFER in,
    const int w, int const h);

GLOBAL(void)
fdct_inverse_image(RCOEFBUFFER coefdct, RSAMPBUFFER out,
    const int w, int const h);

GLOBAL(void)
fidct_buffer(RCOEFBUFFER coef_block, RSAMPBUFFER output_buf);

GLOBAL(void)
fdct_buffer(RSAMPBUFFER in_data, RCOEFBUFFER out_data);

GLOBAL(void)
add_restorator(j_decompress_ptr cinfo, struct jpeg_restoration *the_rest);

GLOBAL(void)
rest_process_restorators(j_decompress_ptr cinfo,
    JSAMPIMAGE output_buf, const jvirt_barray_ptr whole_image[]);
